<template>
  <div>
    <div
      v-if="!optionsExpanded"
      class="scenario-show-options"
      @click="toggleOptions"
    >
      Показать настройки <i class="icon chevron-down" />
    </div>

    <div
      v-else
      class="scenario-options"
    >
      <div class="row">
        <div class="col-xs-3 options-parameters">
          <div>
            Поставщиков в распределении:

            <span
              class="options-link"
              @click="onOpenFilterModal('filter-contractors-modal')"
            >
                {{ optionsContractorsTitle }}
              </span>
          </div>

          <div>
            Фильтр граничных значений:

            <span
              :class="[ 'options-link' ]"
              @click="onOpenFilterModal('filter-edges-modal')"
            >
                {{ optionsEdgesTitle }}
              </span>
          </div>

          <div class="options-flex">
            Учитывать гарантии и объемы

            <ObSwitcher
              v-model="scenarioParams.ACCOUNT_GUARANTEED_VOLUMES"
              :value-left="true"
              :value-right="false"
              :is-disabled="isOptionsDisabled || isSwitcherDisabled"
            />
          </div>

          <div
            class="options-flex"
            v-if="scenarioParams.ACCOUNT_GUARANTEED_VOLUMES"
          >
            Приоритет:

            <ObRadio
              label="Цены"
              value-input="PRICE_PRIORITY"
              v-model="options.priority"
              :disabled="isOptionsDisabled"
              @change="onRadioChange"
            />

            <ObRadio
              label="Гарантий"
              value-input="GUARANTEED_VOLUMES_PRIORITY"
              v-model="options.priority"
              :disabled="isOptionsDisabled"
              @change="onRadioChange"
            />
          </div>
        </div>

        <OptionsColumn
          title="Количество поставщиков"
          :lot-from.sync="scenarioParams.CONTRACTOR_COUNT_LIMIT_PER_LOT_FROM"
          :lot-to.sync="scenarioParams.CONTRACTOR_COUNT_LIMIT_PER_LOT_TO"
          :purchase-from.sync="scenarioParams.CONTRACTOR_COUNT_LIMIT_PER_PURCHASE_FROM"
          :purchase-to.sync="scenarioParams.CONTRACTOR_COUNT_LIMIT_PER_PURCHASE_TO"
          :disabled="isOptionsDisabled"
        />

        <OptionsColumn
          title="Доля затрат на поставщика"
          :lot-from.sync="scenarioParams.CONTRACTOR_COST_LIMIT_PER_LOT_FROM"
          :lot-to.sync="scenarioParams.CONTRACTOR_COST_LIMIT_PER_LOT_TO"
          :purchase-from.sync="scenarioParams.CONTRACTOR_COST_LIMIT_PER_PURCHASE_FROM"
          :purchase-to.sync="scenarioParams.CONTRACTOR_COST_LIMIT_PER_PURCHASE_TO"
          :disabled="isOptionsDisabled"
          :with-percent="true"
        />

        <OptionsColumn
          title="Доля перевозок поставщика"
          :lot-from.sync="scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_LOT_FROM"
          :lot-to.sync="scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_LOT_TO"
          :purchase-from.sync="scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_PURCHASE_FROM"
          :purchase-to.sync="scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_PURCHASE_TO"
          :disabled="isOptionsDisabled"
          :with-percent="true"
        >
          <div class="options-actions">
            <ObButton
              v-if="isOptionsChanged && !isOptionsDisabled"
              label="Пересчитать"
              :mini="true"
              @click="recalculateScenario"
            />

            <div
              class="options-action"
              @click="toggleOptions"
            >
              Скрыть <i class="icon chevron-up" />
            </div>
          </div>
        </OptionsColumn>
      </div>
    </div>

    <FilterEdgesModal
      ref="filter-edges-modal"
      :tender-uuid="tenderUuid"
      :scenario-uuid="scenarioUuid"
      :filter-edges-items="filterEdgesItems"
      :isOptionsDisabled="isOptionsDisabled"
    />

    <ContractorsModal
      v-if="Object.keys(scenarioParams).length"
      ref="filter-contractors-modal"
      :tender-uuid="tenderUuid"
      :scenario-uuid="scenarioUuid"
    />
  </div>
</template>

<script>
  import ObButton from "common-components/src/obComponents/obButton";
  import ObRadio from "common-components/src/obComponents/obRadio";
  import ObSwitcher from "common-components/src/obComponents/obSwitcher";
  import FilterEdgesModal from "../components/filterEdgesModal";
  import ContractorsModal from "../components/contractorsModal";
  import OptionsColumn from './optionsColumn';
  import { mapGetters, mapActions } from 'vuex';

  export default {
    name: "tender-scenario-options",
    components: {
      ObButton,
      ObRadio,
      ObSwitcher,
      FilterEdgesModal,
      ContractorsModal,
      OptionsColumn
    },
    props: {
      tenderUuid: {
        type: String,
        required: true
      },
      scenarioUuid: {
        type: String,
        required: true
      }
    },
    data () {
      return {
        optionsExpanded: false,
        filterEdgesItems: [
          {
            title: "Не выбран",
            type: null
          },
          {
            title: "Отклонение от среднего",
            type: "average"
          }
        ]
      }
    },
    computed: {
      ...mapGetters({
        scenario: "tendersScenario/scenario",
        initialParams: "tendersScenario/initialParams",
        contractorsCount: "tendersScenario/contractorsCount",
        isOptionsDisabled: "tendersScenario/isOptionsDisabled"
      }),
      isOptionsChanged: ({ scenarioParams, initialParams }) => initialParams !== JSON.stringify(scenarioParams),
      isSwitcherDisabled: ({ scenarioParams }) => {
        return scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_LOT_FROM !== '' ||
               scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_LOT_TO !== '' ||
               scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_PURCHASE_FROM !== '' ||
               scenarioParams.CONTRACTOR_VOLUME_LIMIT_PER_PURCHASE_TO !== ''
      },
      optionsContractorsTitle: ({ contractorsCount, scenarioParams }) => {
        if (scenarioParams.CONTRACTOR_FILTER.length) {
          return `${contractorsCount - scenarioParams.CONTRACTOR_FILTER.length} из ${contractorsCount}`;
        } else {
          return `Все (${contractorsCount})`;
        }
      },
      optionsEdgesTitle: ({ filterEdgesItems, scenarioParams }) => {
        return filterEdgesItems.find(item => item.type === scenarioParams.DEVIATION_TYPE).title
      },
      scenarioParams: {
        get () {
          return this.$store.state.tendersScenario.scenario.params
        },
        set (value) {
          this.$store.dispatch("tendersScenario/setParams", value)
        }
      },
      options: {
        get () {
          return this.$store.state.tendersScenario.options
        },
        set (value) {
          this.$store.dispatch("tendersScenario/setOptions", value)
        }
      }
    },
    methods: {
      ...mapActions({
        setOptions: 'tendersScenario/setOptions'
      }),
      toggleOptions() {
        this.optionsExpanded = !this.optionsExpanded
      },
      onRadioChange(e) {
        this.scenarioParams.PRICE_PRIORITY = false;
        this.scenarioParams.GUARANTEED_VOLUMES_PRIORITY = false;
        this.scenarioParams[e] = true;
      },
      onOpenFilterModal(name) {
        if (name === 'filter-edges-modal') {
          this.setOptions({
            edges: {
              type: this.scenarioParams.DEVIATION_TYPE,
              min: this.scenarioParams.DEVIATION_PER_LOT_FROM,
              max: this.scenarioParams.DEVIATION_PER_LOT_TO
            },
            includedDeviations: this.scenarioParams.INCLUDED_DEVIATIONS
          });
        }

        this.$refs[name].open();
      },
      recalculateScenario() {
        this.$emit('recalculate-scenario');
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .scenario-show-options {
    @include font-mixin(12px, 12px, 400, $color-blue-navy-blue, 0.4px);

    padding: 15px;
    text-align: center;
    cursor: pointer;
    display: flex;
    align-items: center;
    justify-content: center;

    i {
      margin-left: 10px;
      font-size: 12px;
      font-weight: bold;
    }
  }

  .scenario-options {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    margin-top: 20px;
    padding: 20px;
    background-color: $color-white-lilac;
  }

  .options-parameters {
    display: grid;
    grid-row-gap: 15px;
    grid-auto-rows: min-content;
  }

  .options-link {
    color: $color-blue-navy-blue;
    cursor: pointer;

    &.disabled {
      color: $color-text-base;
      cursor: default;
    }
  }

  .options-actions {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-top: 20px;
  }

  .options-action {
    color: $color-blue-navy-blue;
    font-size: 12px;
    display: flex;
    align-items: center;
    justify-content: center;
    cursor: pointer;
    margin-left: auto;

    i {
      margin-left: 8px;
      font-size: 12px;
      font-weight: bold;
    }
  }

  .options-flex {
    display: flex;
    align-items: center;

    & > div {
      margin-left: 10px;
    }
  }
</style>